VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSession"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---!!!Copied from ASP file clsSession.asp.
'---!!!There are dome minor modifications to file
'---!!!search for '---!!!(three dash and three exclamaions to see the changes

'---!!! Two files are copied clsSession.ASP and daSession.ASP
'---!!! You can also make this as two classes. But require more work
'---!!! You have decide upon the commn between the two objects(a.k.a classes)
'---!!! It can either be ADODB.Recordset or Flattened string

'---!!! Here we put it in same class so daSession(Data Access Layer) can directly
'---!!! access the private variables of clsSession(Common Business Objects)

Option Explicit
Const con_Active = "A"
Const con_InActive = "I"

'********************************************************
'Start copy of clsSession.asp
'********************************************************
'This will map to two tables in the Database
'SessionHdr
'SessionDet

'**************************************************************
'** FILE DESCRIPTOR ***
'** Author : Chalam
'**
'** Created Date : 01/Aug/2K
'**
'** Description : Common Business Objects. This will control encapsulate the business logic, checkings etc.
'**             : This independent of User Interface and Data storage mechanism
'**
'** Affects : All ASP file which requires session
'*************************************************************

'---!!! Class cSession '---!!!Class name not reqd in VB
Private mstrSessionID, mstrLogIP, mdtLogDate, mdtLogOutDate, mstrStatus
Private mcolSessionVars 'as dictionary
Private flgDirty

Private conDB As ADODB.Connection '---!!!


    Property Get SessionID()
        SessionID = mstrSessionID
    End Property
        Property Get LogIP()
        LogIP = mstrLogIP
    End Property
    
    Property Get LogDate()
        LogDate = mdtLogDate
    End Property
    
    Property Get Status()
        Status = mstrStatus
    End Property
    
    Property Let SessionID(value)
        mstrSessionID = Trim(value)
    End Property
    
    Property Let LogIP(value)
        mstrLogIP = Trim(value)
        flgDirty = True
    End Property
    
    Property Let Status(value)
        mstrStatus = Trim(value)
        flgDirty = True
    End Property
        
    Property Get SessionVars()
        Set SessionVars = mcolSessionVars
    End Property
    
    Property Let Item(name, value)
        name = UCase(name)
        If mcolSessionVars.Exists(name) Then
            mcolSessionVars.Item(name) = value
        Else
            mcolSessionVars.Add name, value
        End If
        flgDirty = True
    End Property
    
    Property Get Item(name)
        name = UCase(name)
        If mcolSessionVars.Exists(name) Then
            Item = mcolSessionVars.Item(name)
        Else
            Item = ""
        End If
    End Property
    
    '---!!! Private Sub Class_Initialize()
    Public Sub Init() '---!!!
        InitializeVars
        If RetriveSessionID Then
            If Not Load(mstrSessionID) Then
                CreateNewSession
            End If
        Else
            CreateNewSession
        End If
    End Sub
    
    Private Sub Class_Terminate()
    On Error Resume Next
        Save
        conDB.Close
        Set conDB = Nothing
    End Sub
    
    Private Sub InitializeVars()
        'Initialize vars
        If IsEmpty(mstrSessionID) Then
            mstrSessionID = ""
        End If
        If IsEmpty(mstrLogIP) Then
            mstrLogIP = ""
        End If
        mstrStatus = ""
        flgDirty = False
        '---!!!Set mcolSessionVars = server.CreateObject("Scripting.Dictionary") '---!!! No server.createobject
        Set mcolSessionVars = New Dictionary
        
        '---!!!Include Connection information
        Set conDB = New ADODB.Connection
        conDB.Open con_DSN, con_DBUserName, con_DBPassword
    End Sub
    
    Private Function RetriveSessionID() 'Will Retrive BasketID if found and return true. Else, Create New basketid, store in clients computer and return false
        RetriveSessionID = False
        '---!!!mstrSessionID = GetString("SessionID", 38, False)
        If Not Len(mstrSessionID) = 0 Then 'Go ahead
            RetriveSessionID = True
        End If  'Len(mstrBasketId) = 0
    End Function
    
    Private Function CreateNewSession()
        Dim flgStatus
        flgStatus = CreateSessionID
        flgStatus = flgStatus And StoreSessionID
        If flgStatus Then
            mstrStatus = con_Active
            mdtLogDate = Date & " " & Time
            '---!!!mstrLogIP = Request.ServerVariables("REMOTE_ADDR")
        End If
        Save
        CreateNewSession = flgStatus
    End Function
    
    Private Function CreateSessionID()
        'Create Some Unique ID.
        CreateSessionID = False
        mstrSessionID = GetUniqueId 'from i_util.asp
        mstrStatus = con_Active
        flgDirty = True
        CreateSessionID = True
    End Function
    
    Private Function StoreSessionID()
        'Using Cookies to store SessionID in client. Alternatively we can use querystring, If at all you are worried about enabling cookie by the user.
        'BTW, a serious shopper is willing to give his credit card number in this site, then y not allow our cookie(which is totally harmless) in his computer?.
        'There are very minor security issues regarding cookie.
        StoreSessionID = False
        '---!!!Response.Cookies("SessionID") = mstrSessionID
        '---!!!Response.Cookies("SessionID").Expires = DateAdd("d", 1, Date)
        StoreSessionID = True
    End Function
    
    Public Function Abandon()
        mstrStatus = con_InActive
        mdtLogOutDate = Date & " " & Time
        flgDirty = True
        Save
    End Function
    
    Public Function Load(strSessionID)
        Load = daLoad(strSessionID)
    End Function
    
    Public Function Save()
        If flgDirty And mcolSessionVars.Count > 0 Then
            Save = daSave
        Else
            Save = False
        End If
    End Function
'---!!! %> '---!!! ASP Specific tags
'---!!!     <!--#include file = "daSession.asp"--> '---!!! Instead of Include file, Copy paste the file into the VB Code

'****************************************************************
'**Copied from daSession.asp
'****************************************************************
'**************************************************************
'** FILE DESCRIPTOR ***
'** Author : Chalam
'**
'** Created Date : 01/Aug/2K
'**
'** Description : Data Access Layer. This will control the information storage and retrival
'**             : Now, Writing to database on server side and cookie to store the session id on the client side
'**
'** Affects : clsSession.ASP. This file is included
'*************************************************************
Private Function daLoad(strSessionID)
    daLoad = False
    Dim rs 'as recordeset
    '---!!! Set rs = server.CreateObject("ADODB.Recordset") '---!!!No Server Objects
    Set rs = New ADODB.Recordset
    
    '---!!!rs.open Replace(Application("qry_Session_Active_PK"), ":1", strSessionID), conDB, adOpenForwardOnly, adLockReadOnly
    rs.Open Replace(con_strqry_Session_Active_PK, ":1", strSessionID), conDB, adOpenForwardOnly, adLockReadOnly
    If Not rs.EOF Then
        mstrSessionID = Trim(rs.Fields("SessionID")) & ""
        mstrLogIP = Trim(rs.Fields("LogIP")) & ""
        mdtLogDate = Trim(rs.Fields("LogDate")) & ""
        mstrStatus = Trim(rs.Fields("Status")) & ""
            
        '---!!! Set mcolSessionVars = server.CreateObject("Scripting.Dictionary") '---!!!No Server Objects
        Set mcolSessionVars = New Dictionary
        
        Do While Not rs.EOF
            mcolSessionVars.Add Trim(rs.Fields("name")), Trim(rs.Fields("value"))
            rs.MoveNext
        Loop
        flgDirty = False
        daLoad = True
    End If
    rs.Close
    Set rs = Nothing
End Function

Private Function daSave()
    'Save the object
    Dim tstrKey
    daSave = False
    Dim rs 'as recordeset
    '---!!! Set rs = server.CreateObject("ADODB.Recordset")'---!!! NO Server Objects
    Set rs = New ADODB.Recordset
        
    '---!!!rs.open Replace(Application("qry_SessionHdr_PK"), ":1", mstrSessionID), conDB, adOpenDynamic, adLockOptimistic
    rs.Open Replace(con_strqry_SessionHdr_PK, ":1", mstrSessionID), conDB, adOpenDynamic, adLockOptimistic
    If rs.EOF Then  'New member
        rs.AddNew
        rs.Fields("SessionID") = mstrSessionID
    End If
    rs.Fields("LogIP") = mstrLogIP
    rs.Fields("LogDate") = mdtLogDate
    rs.Fields("LogOutDate") = mdtLogOutDate
    rs.Fields("Status") = mstrStatus
    rs.Update
    rs.Close
    'Save Detail...
    For Each tstrKey In mcolSessionVars.Keys
        '---!!!rs.open Replace(Replace(Application("qry_SessionDet_PK"), ":1", mstrSessionID), ":2", tstrKey), conDB, adOpenDynamic, adLockOptimistic
        rs.Open Replace(Replace(con_strqry_SessionDet_PK, ":1", mstrSessionID), ":2", tstrKey), conDB, adOpenDynamic, adLockOptimistic
        If rs.EOF Then
            rs.AddNew
            rs.Fields("SessionID") = mstrSessionID
        End If
        rs.Fields("name") = tstrKey
        rs.Fields("value") = mcolSessionVars.Item(tstrKey)
        rs.Update
        rs.Close
    Next
    Set rs = Nothing
    daSave = True
End Function
'***********************************************************************
'**End of daSession.asp copy.
'***********************************************************************
'---!!! <% '---!!! ASP Specific tags
'---!!! End Class '---!!! End Class stmnt not reqd in VB


