<%
'This will map to two tables in the Database
'SessionHdr
'SessionDet

'**************************************************************
'** FILE DESCRIPTOR ***
'** Author : Chalam
'**
'** Created Date : 01/Aug/2K
'**
'** Description : Common Business Objects. This will control encapsulate the business logic, checkings etc.
'**				: This independent of User Interface and Data storage mechanism
'**
'** Affects : All ASP file which requires session
'*************************************************************

Const con_Active = "A"
Const con_InActive = "I"
Class cSession
	Private mstrSessionID, mstrLogIP, mdtLogDate, mdtLogOutDate, mstrStatus
	Private mcolSessionVars 'as dictionary
	Private flgDirty
	
	Property Get SessionID
		SessionID = mstrSessionID
	End Property 
	
	Property Let SessionID(value)
		mstrSessionID = Trim(value)
		flgDirty = true
	End Property 
	
	Property Get LogIP
		LogIP = mstrLogIP
	End Property 
	
	Property Let LogIP(value)
		LogIP = Trim(value)
		flgDirty = true
	End Property 
	
	Property Get LogDate
		LogDate = mdtLogDate
	End Property 	
	
	Property Get Status
		Status = mstrStatus
	End Property 
	Property Let Status(value)
		mstrStatus = trim(value)
		flgDirty = True
	End Property 
		
	Property Get SessionVars
		Set SessionVars = mcolSessionVars
	End Property 
	
	Property Let Item(name, value)
		name = ucase(name)
		if mcolSessionvars.Exists(name) then
			mcolSessionvars.Item(name) = value
		Else
			mcolSessionvars.Add name, value
		End if
		flgDirty = True
	End Property
	
	Property Get Item(name)
		name = ucase(name)
		if mcolSessionvars.Exists(name) then
			Item = mcolSessionvars.Item(name)
		Else
			Item = ""
		End if
	End Property
	
	Private Sub Class_Initialize()
		InitializeVars
		if RetriveSessionID Then 
			if Not Load(mstrSessionID) Then
				CreateNewSession
			End if
		Else
			CreateNewSession
		End if		
	End Sub
	
	Private Sub Class_Terminate()				
		Save 			
	End Sub
	
	Private Sub InitializeVars()
		'Initialize variables		
        If IsEmpty(mstrSessionID) Then
            mstrSessionID = ""
        End If
        If IsEmpty(mstrLogIP) Then
            mstrLogIP = ""
        End If
		mstrStatus = ""
		flgDirty = false
		Set mcolSessionVars = Server.CreateObject("Scripting.Dictionary")
	End Sub
	
	Private Function RetriveSessionID() 'Will Retrive Session ID if found and return true. Else, Create New basketid, store in clients computer and return false
		RetriveSessionID  = false	
		mstrSessionID = Getstring("SessionID", 38, false) 'Will be getting from Querystring or Cookie.						
		if Not Len(mstrSessionID) = 0 Then 'Go ahead			
			RetriveSessionID  = True			
		End if	'Len(mstrBasketId) = 0 
	End Function
	
	Private Function CreateNewSession()
		Dim flgStatus
		flgStatus = CreateSessionID
		flgStatus =  flgStatus and StoreSessionID
		if flgStatus Then
			mstrStatus = con_Active
			mdtLogDate =Date & " " & Time
			mstrLogIP = Request.ServerVariables("REMOTE_ADDR")
		End if
		Save
		CreateNewSession = flgStatus 
	End Function
	
	Private Function CreateSessionID()
		'Create Some Unique ID.		
		CreateSessionID = False		
		mstrSessionID = GetUniqueId 
		mstrStatus = con_Active			
		flgDirty = True
		CreateSessionID = True
	End Function
	
	Private Function StoreSessionID()
		'Using Cookies to store SessionID in client. Alternatively we can use querystring, If at all you are worried about enabling cookie by the user. 
		'BTW, a serious shopper is willing to give his credit card number in this site, then y not allow our cookie(which is totally harmless) in his computer?.
		'There are very minor security issues regarding cookie.			
		StoreSessionID = False
		Response.Cookies("SessionID") = mstrSessionID
		Response.Cookies("SessionID").expires = DateAdd("d", 1, Date)			
		StoreSessionID = True 
	End Function
	
	Public Function Abandon()
		mstrStatus = con_InActive
		mdtLogOutDate = Date & " " & Time
		flgDirty = True
		Save
	End Function
	
	Public Function Load(strSessionID)
		Load = daLoad(strSessionID)		
	End Function
	
	Public Function Save()
		if flgDirty and mcolSessionVars.Count > 0 Then
			Save = daSave
		Else
			Save = False
		End if
	End Function
%>
	<!--#include file = "daSession.asp"-->
<%	
End Class
%>
