<!--#include file = "i_db_conn.asp" -->
<!--#include file = "clsSession.asp" -->
<% 
'**************************************************************
'** FILE DESCRIPTOR ***
'** Author : Chalam
'**
'** Description : Commonly used functions in ASP pages
'**
'** Affects : All ASP pages. All ASP Page should include this file
'**************************************************************

'**************************************************************
'** FUNCTION DESCRIPTOR ***
'** Author : Chalam
'**
'** Description : Used To get the string. Removes the headache of multiple input protocol.
'**				  Priority to Querystring. Trims and produce safe string.
'**
'** Input	: strKey, Key part of Key-Value Pair to query the request object
'**			  dblMaxLength, Maximum length expected. If Value entered is greater than maxlength, it trims to this length 	
'**		      blnQuerySafe - True if the output is need to be send to database as a part of query
'**
'** Output	: Function Returns safe string
'**
'** Affects : All ASP pages. All ASP Page should include this file
'**
'** Implications : The name should be unique. Say for ex, the request to retrive the value with name 'x' then
'**				   the function looks for x in querystring, then in form(posted) and then in cookie in that order.
'**				   if x is found both in cookie and querystring, the value stored in cookie is ignored.
'**************************************************************


Dim objSession
CreateSession()
Function GetString(strKey,  dblMaxLength, blnQuerySafe)
	Dim strtValue
	On Error Resume Next
	strtValue = ""
	strtValue = Trim(Request.QueryString(strKey))
	if Len(strtvalue) = 0 Then
		strtValue = Trim(Request.Form(strKey))
	End if
	if Len(strtvalue) = 0 Then
		strtValue = Trim(Request.Cookies(strKey))
	End if	
	if Len(strtvalue) > dblMaxLength Then
		strtvalue = Left(strKey, dblMaxLength)
	End if
	if blnQuerySafe Then
		strtvalue = Replace(strtvalue, "'", "''")
	End if 
	GetString = strtValue
End Function

Private Function CreateSession()
	Set objSession = New cSession	
End Function

%>